theory Code_gdb_script
imports Main
begin

datatype  gdb_comand =     
   break string gdb_comand
 | commands gdb_comand
 | silent  gdb_comand
 | continue gdb_comand
 | thread   gdb_comand
 | "end"    gdb_comand 
 | sharp string
 |start

datatype gdb_option =
  logging gdb_option
 |on
 |off
 |pagination gdb_option
 |"file" string
 |print gdb_option


datatype in_c = alloc  int int int
              | release int int int
              | status  int int 
              

subsection {*writing on file using Isabelle/ML*}
ML{*
    val file_path_office = Path.explode "/cygdrive/d/YakoubDontTouch/TheseBiell/HOL-TestGen/add-ons/OS-IFP-test/OS_kernel_model/IPC/example_gdb_impl/c/yakoub.gdb";
    val file_path_home = Path.explode "/cygdrive/g/TheseBielle/hol-testgen/add-ons/OS-IFP-test/OS_kernel_model/IPC/example_gdb_impl/c/yakoub.gdb";
    val file_check = File.exists file_path_home; 
    val file_write = File.write file_path_office "#yakoub"; 

*}

subsection {*Printing a list of terms in column using Pretty*}
ML{*
    fun pretty_terms' context terms = terms |> (Syntax.pretty_term context 
                                                |> List.map)
                                            |> Pretty.chunks;

     Pretty.writeln (pretty_terms' @{context} [@{term "2::int"}, @{term "2::int"}]);    
*}

subsection {*Going from a list of terms to ASCII string*}
ML {*(*fun render_thm ctxt thm =
     Print_Mode.setmp ["xsymbols"]
    (fn _ => Display.pretty_thm ctxt thm
             |> Pretty.str_of
             |> YXML.parse_body
             |> XML.content_of) ();
    render_thm @{context} @{thm "conjI"};*)
    fun render_term ctxt term =
     Print_Mode.setmp ["xsymbols"]
    (fn _ =>  Syntax.pretty_term ctxt term
             |> Pretty.str_of
             |> YXML.parse_body
             |> XML.content_of) ();

   render_term @{context} @{term "1::int"};

   fun render_term_list ctxt term =
     Print_Mode.setmp ["xsymbols"]
    (fn _ =>  pretty_terms' ctxt term
             |> Pretty.str_of
             |> YXML.parse_body
             |> XML.content_of) ();
   render_term_list @{context} [@{term "1::int"}, @{term "1::int"}];  
*}


subsection {*GDB terms script to control scheduler*}

ML {*val gdb_header =  
         @{term "''#setting gdb options''"} $
         @{term "set"} $ @{term "logging (file ''Example_sequential.log'')"} $ @{term "''{''"} $
         @{term "set"} $ @{term "logging on"} $ @{term "''{''"} $
         @{term "set"} $ @{term "pagination off"} $ @{term "''{''"} $
         @{term "set ''target-async''"} $ @{term " on"} $ @{term "''{''"} $
         @{term "set ''non-stop''"} $ @{term " on"} $ @{term "''{''"} $
         @{term "set ''print thread-events off''"} $ @{term "''{''"} $ @{term "''{''"}
         ;
 
     fun gdb_break_point_entry fun_nam_term thread_id_term = 
         @{term "''#setting thread entry''"} $
         @{term "break"}  $ fun_nam_term $ @{term "''{''"} $ 
         @{term "commands"} $ @{term "''{''"} $ 
         @{term "silent"} $ @{term "''{''"} $  
         @{term "thread"} $ thread_id_term $ @{term "''{''"} $
         @{term "continue"} $ @{term "''{''"} $
         @{term "end"} $ @{term "''{''"} $ @{term "''{''"};
      
   
     fun gdb_break_point_exist line_number_term thread_id_term = 
         @{term "''#setting thread exit''"} $
         @{term "break"}  $ line_number_term $ @{term "''{''"} $ 
         @{term "commands"} $ @{term "''{''"} $ 
         @{term "silent"} $ @{term "''{''"} $  
         @{term "thread"} $ thread_id_term $ @{term "''{''"} $
         @{term "continue"} $ @{term "''{''"} $
         @{term "end"} $ @{term "''{''"} $ @{term "''{''"};
     
     val gdb_start_term = @{term "start"} $ @{term "''{''"};

*}
 

ML {* gdb_header*}

subsection {*Going from a datatype term to GDB term*}
       
ML{*    
    fun actTerm_to_gdbTerm (Const(@{const_name "alloc"}, typ) $ _ $ B $ _)= 
        gdb_header $ gdb_break_point_entry (Const(@{const_name "alloc"}, typ)) B $ 
        gdb_break_point_exist @{term "0"} B
      | actTerm_to_gdbTerm (Const(@{const_name "release"}, typ) $ _ $ B $ _)= 
        gdb_header $ gdb_break_point_entry (Const(@{const_name "release"}, typ)) B $
        gdb_break_point_exist @{term "0"} B
      | actTerm_to_gdbTerm (Const(@{const_name "status"}, typ) $ _ $ B)= 
        gdb_header $ gdb_break_point_entry (Const(@{const_name "alloc"}, typ)) B $
        gdb_break_point_exist @{term "0"} B
     | actTerm_to_gdbTerm (Const(@{const_name "end"}, typ) $ _)= 
        @{term "start"};
    *}



subsection {*removing quotes and parentheses from ASCII string*}
ML {*  fun remove_char nil = [] 
      |  remove_char (x::xs) = (if ((x = #"(" orelse x = #")") orelse x = #"'")   
                                then remove_char xs 
                                else x::remove_char xs); 
   *}

subsection {*Jump to the next line*}

ML {*  fun next_line nil = [] 
      |  next_line (x::xs) = (if x = #"{"    
                              then next_line (#"\n"::xs) 
                              else x::next_line xs); 
   *}

subsection {*Example*}

ML {* val print_this = actTerm_to_gdbTerm (Const(@{const_name "alloc"}, @{typ "gdb_comand"}) $ @{term 0} $ @{term 1} $ 
     @{term 5}) $ @{term "start"};
     val save_this = render_term_list @{context} [print_this];
    File.write file_path_office ((String.implode o next_line o remove_char o String.explode) save_this);
*}


subsection {*Going from a simple list to a list of terms*}

ML {*render_term_list @{context} [@{term " ''{''"}]*}
end
